/*
ͻ
 NOM       : CONVERTC.C: Procdures ConvAscii et ConvHexa                    
 VERSION   : v 1.0                                                           
 STRUCTURE : A compiler avec TC.EXE.                                         
 FONCTION  : Dmonstration des procdures de transcodage ASCII<-->HEXA       
           : dveloppes en langage C.                                       
           : Leur but est de permettre  une application utilisant           
           : SERIAL MANAGER avec le protocole Xon/Xoff actif de transmet-    
           : -tre des informations binaires quelconques, sans interfrer     
           : avec le protocole de contrle de flux du pilote srie.          
           : ATTENTION:A chaque code binaire sont associs 2 codes ASCII.    
           : Le dbit utile de transmission sera donc dgrad du fait        
           : de l'utilisation de ce transcodage. Donc, N'UTILISER CES        
           : PROCEDURES QU'EN CAS DE VERITABLE NECESSITE...                  
 SYNTAXE   : CONVERTC                                                        
 COPYRIGHT : HETRU Fabrice 1991-1993.                                        
ͼ
*/


#include "stdio.h" /* entres/sorties */
#include "dos.h"   /* structures regs.*/

union    REGS inregs,outregs;
struct   SREGS segregs;



void ConvAscii(unsigned char *pte, unsigned char *pts)
/* Conversion en 2 codes ASCII de *pte dans *pts et *pts++...              */
  {
  unsigned char car,val;

  /* Mmorisation du nombre Hexa. */
  val = *pte;
  /* Conversion du demi-octet gauche */
  car = (val >> 4) + '0';
  *pts++ = car;
  /* Conversion du demi-octet droit */
  car = (val & 0x0F) + '0';
  /* Envoit du rsultat */
  *pts = car;
  }


void ConvHexa(unsigned char *pte, unsigned char *pts)
/* Conversion en 1 HEXA des 2 codes ASCII de *pte et *pte++ dans *pts.     */
  {
  unsigned char car;

  /* Conversion du demi-octet gauche */
  car = (*pte++ - '0') << 4;
  /* Conversion du demi-octet droit */
  car = car + (*pte - '0');
  /* Envoit du rsultat */
  *pts = car;
  }


int get_clav()
  {
  int l;

  inregs.h.ah = 0;
  int86(0x16,&inregs,&outregs);
  l = outregs.h.al;
  if (l==3) l = 67;
  return(l);
  }


main ()
  {
  char fin;
  char caract;
  unsigned int dest;
  unsigned char *pt;

  fin = 0;
  printf("CONVERTC: Dmonstration des procdures de transcodage.\n");
  printf("      (Entrez 'Esc' pour quitter le programme).\n");
  while(!fin)
    {
    /* Lecture et affichage du code lu */
    printf("\nCaractre: ");
    caract = get_clav();
    if (caract!=0x0d)
      printf("%c/%x",caract,caract);
    else printf("  /%x",caract);
    if (caract==0x1b) fin = 1;

    /* convertion HEXA-->ASCII */
    ConvAscii(&(char)caract,&(char)dest);
    /* Affichage du code obtenu */
    pt = &(char)dest + 1;
    printf(" --ConvAscii--> %c%c",(char)*pt,(char)dest);

    /* ICI LES 2 CODES de CARACT. ASCII OBTENUS PEUVENT ETRE TELECOMMUNIQUES
       SANS RISQUE D'INTERFERER AVEC LES CODES DE CONTROLE DE FLUX
       (dont les codes sont compris entre 0 et 29h inclus...).
       INCONVENIENT de la mthode: pour 1 octet  mettre, il faut en
       fait envoyer 2 octets !... */

    /* convertion ASCII-->HEXA */
    ConvHexa(&(char)dest,&(char)caract);
    /* Affichage du code reconstitu (=1ier code si correct) */
    if (caract!=0x0d)
      printf(" --ConvHexa--> %c/%x",caract,caract);
    else printf(" --ConvHexa-->   /%x",caract);
    }
  printf("\nFin de CONVERTC (C)HETRU Fabrice.\n");
  }
