{
ͻ
 NOM       : MODEM.PAS                                                       
 FONCTION  : Bibliothque pour commander et contrler le modem utilis       
           : (TlTex ou HAYES pour l'instant...)                            
 REMARQUES :  Pour activer l'interruption d'horloge de cette unit, il faut 
           : insrer les lignes suivantes dans le programme principal:       
           :         GetIntVec($1C,Int1CSave);                               
           :         SetIntVec($1C,Addr(Check_HModem_State));                
           : Ne pas oublier de dsactiver avant de quitter le programme:     
           :         SetIntVec($1C,Int1CSave);                               
           : Cette interruption tiendra  jour la variable "connected" de    
           : seconde en seconde pour un modem Hayes. Elle permet galement   
           : l'affichage du tmoin de connexion (si "Show_CorF" vaut TRUE).  
           : Notez que "HayesModemState" et "Check_HModem_State" ne sont     
           : d'aucun secours pour contrler l'tat de connexion du minitel:  
           : l'tat de connex. de ce dernier doit tre interprt par votre  
           : routine de dcodage du VidoTex...                              
           :  Tenez  jour la variable 'num_com'.                           
 COPYRIGHT : HETRU Fabrice 1991-1993.                                        
ͼ
}



UNIT Modem;



interface

USES Crt,Dos,StarIntf;

TYPE
  CmdeStr = STRING[20] ;

CONST
  (* Codes du type de modem utilis: MINITEL ou HAYES ? *)
  TlTex     = 0 ;
  Hayes     = 1 ;
  (* Codes de commande  envoyer au Modem utilis.      *)
  Generique = 0 ;
  InitMod   = 1 ;
  Connect   = 2 ;
  Appel     = 3 ;
  Raccroch  = 4 ;
  ConnexFin = 5 ;
  (* Segment d'accs  la mmoire vido. *)
  seg_ecran  : WORD = $B000 ;

VAR
  ModemUsed   : SHORTINT  ;    (* Type du modem utilis: Hayes/Minitel ?     *)
  DTR_Cmde    : BOOLEAN   ;    (* Utilisation de DTR comme prfixe de cmde ? *)
  HAYESPrefix : STRING[3] ;    (* Prfixe de commande pour modems-HAYES.     *)
  PulseDial   : BOOLEAN   ;    (* Numrotation par impulsions ? (sinon MFreq)*)
  num_com     : BYTE      ;    (* Port srie utilis ? (1  4).              *)
  connected   : BOOLEAN   ;    (* Indique l'tat de la connexion.            *)
  Show_CorF   : BOOLEAN   ;    (* Affichage du tmoin de connexion ?         *)
  Int1CSave   : POINTER   ;    (* Sauvegarde de l'ancien vecteur...          *)

PROCEDURE CmdeToModem(TypCmde: BYTE;DataCmde: CmdeStr);
                                         { Gnration Cmdes HAYES et TlTex.   }
PROCEDURE HayesModemState;               { Met  jour l'tat de connexion.    }
PROCEDURE Check_HModem_State; INTERRUPT; { Interruption d'horloge pour la     }
                                         { surveillance de la connexion...    }



implementation

TYPE
  Vecteur = RECORD
              Offset  : WORD ;
              Segment : WORD ;
            END;


CONST
  (* Constante pour mmoriser l'ancien vecteur 1Ch. *)
  OldIntrp1C : Vecteur = (Offset:0;Segment:0) ;


VAR
  reg88        : Registers ;
  ItClk_active : BOOLEAN   ;


PROCEDURE Beep(Freq, Tempo: WORD);
  BEGIN
    Sound(Freq);
    Delay(Tempo);
    NoSound
  END;


PROCEDURE CmdeToModem(TypCmde: BYTE;DataCmde: CmdeStr);
  VAR
    Chaine_CMDE   : CmdeStr ;
    Sended,
    Nb_transmited : WORD    ;
  BEGIN
    Chaine_CMDE := '';
    CASE ModemUsed OF
      TlTex: BEGIN
          CASE TypCmde OF
            Generique: Chaine_CMDE := #$1B+#$39+#$67;
            InitMod: Chaine_CMDE := '';
            Connect: Chaine_CMDE := #$1B+#$39+#$68;
            Appel: Chaine_CMDE := '';
            Raccroch: Chaine_CMDE := #$1B+#$39+#$67;
            ConnexFin: IF connected THEN Chaine_CMDE := #$13+#$49
                         ELSE Chaine_CMDE := #$1B+#$39+#$68
          END;
          IF Length(Chaine_CMDE)>0 THEN
            IF WriteSerie(Chaine_CMDE[1],Length(Chaine_CMDE),Nb_transmited)<>0
              THEN Beep(500,500)
        END;
      Hayes: BEGIN
          CASE TypCmde OF
            Generique: Chaine_CMDE := Chaine_CMDE + DataCmde;
            InitMod:
              IF DTR_Cmde THEN Chaine_CMDE := 'AT Z0 &D1 X0 V2 B2'
                ELSE Chaine_CMDE := Chaine_CMDE + 'AT Z0 X0 V2 B2';
            Connect: Chaine_CMDE := Chaine_CMDE + 'ATD';
            Appel: IF connected OR (DataCmde='') THEN Chaine_CMDE := ''
                     ELSE
                     BEGIN
                       Chaine_CMDE := Chaine_CMDE + 'ATD' ;
                       IF PulseDIAL THEN Chaine_CMDE := Chaine_CMDE + 'P'
                         ELSE Chaine_CMDE := Chaine_CMDE + 'T';
                       Chaine_CMDE := Chaine_CMDE + DataCmde
                     END;
            Raccroch: Chaine_CMDE := Chaine_CMDE + 'ATH0';
            ConnexFin: IF connected THEN Chaine_CMDE := Chaine_CMDE + 'ATH0'
                         ELSE Chaine_CMDE := Chaine_CMDE + 'ATD'
          END;
          IF Length(Chaine_CMDE)>0 THEN
          BEGIN
            IF NOT DTR_Cmde THEN
            BEGIN
              IF connected THEN
              BEGIN
                Delay(1000);
                Sended:=WriteCmde(HAYESPrefix[1],Length(HAYESPrefix),DTR_Cmde);
                IF Sended=0 THEN Delay(1000);
              END
              ELSE Sended := 0;
            END
            ELSE Sended := 0;
            IF Sended=0 THEN
            BEGIN
              Chaine_CMDE := Chaine_CMDE + #$0D;
              IF WriteCmde(Chaine_CMDE[1],Length(Chaine_CMDE),DTR_Cmde)<>0
                THEN Beep(500,500);
              IF connected THEN
              BEGIN
                Delay(1200);
                Chaine_Cmde := 'ATO' + #$0D;
                Sended:=WriteCmde(Chaine_CMDE[1],Length(Chaine_CMDE),FALSE);
              END
            END;
          END
        END;
    END
  END;


PROCEDURE HayesModemState;
  VAR
    ModemStatus : BYTE ;
  BEGIN
    IF ModemUsed=Hayes THEN
    BEGIN
      CASE num_com OF
        1: ModemStatus := Port[BasePort1+6] AND $80;
        2: ModemStatus := Port[BasePort2+6] AND $80;
        3: ModemStatus := Port[BasePort3+6] AND $80;
        4: ModemStatus := Port[BasePort4+6] AND $80
      END;
      IF ModemStatus=$80 THEN connected := TRUE
        ELSE connected := FALSE
    END;
  END;


{$F+}
PROCEDURE Check_HModem_State;
  VAR
    compteur : BYTE ;
  BEGIN
    (* Activation traitement toutes les secondes  peu prs... *)
    Inc(compteur);
    IF (compteur>=$12) AND NOT ItClk_active THEN
    BEGIN
      (* Interdiction de r-entrance. *)
      ItClk_active := TRUE;

      (* Acquitement 8259 et CPU pour permettre rceptions sries... *)
      Inline($50/              (* push ax     *)
             $B0/$20/          (* mov  al,20h *)
             $E6/$20/          (* out  20h,al *)
             $58);             (* pop  ax     *)
      Inline($FB);             (* sti         *)

      (* Vrification de l'tat de la connexion. *)
      HayesModemState;

      (* Gestion du tmoin de connexion si ncessaire. *)
      IF Show_CorF THEN
      BEGIN
        IF connected THEN
        BEGIN
          IF MEM[$40:$49] IN [2,3,7] THEN
            MEMW[seg_ecran:158] := $7043
          ELSE MEMW[seg_ecran:76] := $7043
        END
        ELSE
        BEGIN
          IF MEM[$40:$49] IN [2,3,7] THEN
            MEMW[seg_ecran:158] := $7046
          ELSE MEMW[seg_ecran:76] := $7046
        END;
      END;

      (* Reset tmoins de gnration de la prsente interruption. *)
      ItClk_active := FALSE;
      compteur := 0
    END;

    (* Appel imbriqu de l'ancienne int. de l'1Ch *)
    Inline($9C/                (* pushf                            *)
           $FF/$1E/OldIntrp1C) (* call far dword ptr ds:OldIntrp1C *)
  END;
{$F-}


BEGIN
  ModemUsed := Hayes;               (* Type du modem utilis = Hayes...      *)
  DTR_Cmde := TRUE;                 (* Utilisation de DTR comme spcif. cmde.*)
  HAYESPrefix := '+++';             (* Prfixe de cmde HAYES par dfaut.     *)
  PulseDial := TRUE;                (* Numrotation par impulsions par dfaut*)
  num_com := 1 ;                    (* Port srie utilis = 1 par dfaut.    *)
  connected := FALSE;               (* Etat initial suppos: dconnect !    *)
  Show_CorF := FALSE;               (* Affichage du tmoin de connexion = NON*)
  ItClk_active := FALSE;            (* Int. de vrif. pas encore active.    *)
  IF MEM[$0040:$0049]=7 THEN        (* Segment de la mmoire vido  utiliser*)
    seg_ecran := $B000              (* pour afficher le tmoin de connexion. *)
  ELSE seg_ecran := $B800;
  WITH reg88 DO
  BEGIN                             (* Mmo. vecteur ancienne interruption.  *)
    ax := $351C;                    (* pour la redirection par notre IT_Clk. *)
    Intr($21,Dos.Registers(reg88));
    OldIntrp1C.Offset := bx;
    OldIntrp1C.Segment := es;
  END
END.
