{
ͻ
 NOM       : STARINTF.PAS                                                    
 FONCTION  : Procdures d'interfaage du pilote des voies sries RS232C      
           : STARCOMM.EXE au langage PASCAL, qu'il soit charg en tant que   
           : pilote "BIOS" ou en tant que DEVICE DRIVER du DOS.              
 VERSION   : v2.0 (premire dition).                                        
 LANGAGE   : TURBO PASCAL v4.0 et suivants (Rdig comme une "UNIT"...)      
 REMARQUE  : Si un programme appelle quand-mme les fonctions d'accs au port
           : srie alors que "RS_accessible=FALSE" (ou que "COMM_ouvert=     
           : FALSE" pour l'interface au DEVICE DRIVER), les codes rendus se- 
           : ront SANS SIGNIFICATION... Ces appels au pilote seront sans     
           : aucun effet dans ce cas.                                        
           : Pour s'assurer de la prsence du pilote en RAM, vrifier que    
           : "type_driver" est diffrent de 0 !                              
 COPYRIGHT : HETRU Fabrice 1991-1994.                                        
ͼ
}



UNIT StarIntf;



interface

USES Dos;

TYPE
  Chn4octets = STRING[4] ;

CONST
  (* Port srie concern par la fonction appele: 0 (COM1:)  3 (COM4:). *)
  CommPort : WORD = 0 ;
  (* Reprage des ports reconnus comme existants par STARCOMM. Est rensei- *)
  (* -gn par la procdure "Port_Opened".                                  *)
  ComExist : ARRAY[0..3] OF BOOLEAN = (TRUE,TRUE,TRUE,TRUE);
  (* Adresses de base des 8250 pour les COM1  COM4 ? *)
  BasePort1 : WORD = $3F8;
  BasePort2 : WORD = $2F8;
  BasePort3 : WORD = $3E8;
  BasePort4 : WORD = $2E8;
  (* Spcificateurs d'activation des contrles de flux matriels. *)
  RTS_CTS  : BYTE = 1;
  DTR_DSR  : BYTE = 2;
  BothCmde : BYTE = 3;
  (* Spcificateurs des modes de fonctionnement possibles pour *)
  (* les contrles de flux.                                    *)
  Inactif   : BYTE =  0;
  Local     : BYTE = 76; (*'L'*)
  Eloigne   : BYTE = 69; (*'E'*)
  Bilateral : BYTE = 66; (*'B'*)
  (* Codes pour le protocole de contrle de flux logiciel. *)
  Xon  : BYTE = $11;
  Xoff : BYTE = $13;
  (* Modes de fonctionnement pour la substitution des erreurs. *)
  NonActif : BYTE = 0; (* Smode0: Les octets dfectueux sont bufferiss *)
                       (* comme ils sont dcods...                     *)
  Remplace : BYTE = 1; (* Smode1: Octets HS remplacs par code spcial. *)
  RempNULL : BYTE = 2; (* Smode2: Octets HS perdus. Le compteur du nb.  *)
                       (* d'octets perdus est incrment.               *)
  (* Nom du DEVICE DRIVER associ  STARCOMM.EXE. *)
  NomDevice : STRING[8] = 'COMM    ';

VAR
  RS_accessible : BOOLEAN ; (* TRUE=Pilote prsent, FALSE=Pil. absent   *)
  type_driver   : BYTE    ; (* 0=Absent,1=STARCOMM BIOS, 2=en DEV-DRV.  *)
  handler_voie_serie : WORD ;  (* Handler du fichier "COMM".            *)
  COMM_ouvert   : BOOLEAN ; (* Spcificateur d'tat du fichier "COMM".  *)
  Serial_error  : WORD    ; (* Code d'erreur DOS obtenu  l'ouverture...*)

(* Fonctions accessibles via l'interruption dtourne n 14h. *)
PROCEDURE Version(VAR NumVer: Chn4octets);
FUNCTION  Open_Port: BYTE;
FUNCTION  Close_Port: BYTE;
FUNCTION  Port_Opened: BOOLEAN;
FUNCTION  Interdit_Port: BYTE;
FUNCTION  Autorise_Port: BYTE;
FUNCTION  SLOW_Ems: BYTE;
FUNCTION  FAST_Ems: BYTE;
FUNCTION  Send_SLOW: BOOLEAN;
PROCEDURE Get_Ports_Adresses;
FUNCTION  Infos_Uart(VAR Uart_type: BYTE; VAR Uart_adresse: WORD;
          VAR Irq,FIFO_actif,Taille_FIFO: BYTE): BYTE;
FUNCTION  Set_New_Uart(Uart_adresse: WORD;
          Irq,FIFO_actif,Taille_FIFO: BYTE): BYTE;
PROCEDURE Infos_Buffs(VAR Nb_actifs, Nb_maxi: BYTE;
          VAR Taille_InBuff,Taille_OutBuff: WORD);
FUNCTION  Init_Port(longueur, stop_bit, parity: CHAR; vitesse: LONGINT;
          VAR Taille_InBuff: WORD; VAR Taille_OutBuff: WORD): BYTE;
PROCEDURE Init_status(VAR Format: WORD);
FUNCTION  Reset_Init_status(Format: WORD): BYTE;
PROCEDURE Flush_buffers;
PROCEDURE Flush_InBuff;
PROCEDURE Flush_OutBuff;
PROCEDURE ResetPort_and_TimMAX(RdTim_MAX: BYTE; VAR Old_RdTim_MAX: BYTE;
          WrTim_MAX: BYTE; VAR Old_WrTim_MAX: BYTE);
PROCEDURE Status_Trait_Erreurs(VAR mode: BYTE; VAR code: CHAR);
FUNCTION  Def_Trait_Erreurs(mode: BYTE; code: CHAR): BYTE;
FUNCTION  Change_com_port(Num_port: BYTE): BYTE;
FUNCTION  Attend_Buff_ems_vide(Temps_maxi: BYTE): BOOLEAN;
FUNCTION  CheckBufferIn(VAR nb_a_lire: WORD): BOOLEAN;
FUNCTION  CheckBufferOut(VAR place_libre: WORD): BOOLEAN;
FUNCTION  ReadSerie(VAR c: CHAR; nombre: WORD; VAR Nb_received: WORD): BYTE;
FUNCTION  WriteSerie(VAR c: CHAR; nombre: WORD; VAR Nb_written: WORD): BYTE;
FUNCTION  ReadCarSerie(VAR c: CHAR): BYTE;
FUNCTION  WriteCarSerie(c: CHAR): BYTE;
FUNCTION  Peek_rcp(VAR c: CHAR): BYTE;
FUNCTION  Poke_rcp(c: CHAR): BYTE;
FUNCTION  WriteCmde(VAR Cmde: CHAR; nombre: BYTE; UseDTR: BOOLEAN): BYTE;
PROCEDURE Etat_du_Modem(VAR Voie_active: CHAR; VAR Pret, Clear_to_send,
          Sonnerie, Porteuse, Changements, deltaDSR, deltaCTS, deltaRI,
          deltaDCD: BOOLEAN);
PROCEDURE Set_DTR;
PROCEDURE Clear_DTR;
PROCEDURE Set_RTS;
PROCEDURE Clear_RTS;
PROCEDURE Set_OUT1;
PROCEDURE Clear_OUT1;
PROCEDURE Send_break(duree: BYTE);
FUNCTION  Errors_Report(VAR Buff_overflow, Engorgement, Parite, Stop_bit,
          Break_it: BYTE): BOOLEAN;
FUNCTION  Port_Free: BOOLEAN;
FUNCTION  HandShake_Status(Proto_type: BYTE;VAR SendEnabled: BOOLEAN): BYTE;
PROCEDURE HandShake_Setup(Proto_type: BYTE; state: BYTE);
FUNCTION  XonoffShaking_Status(VAR SendEnabled: BOOLEAN;
          VAR Nb_Xoff: BYTE): BYTE;
PROCEDURE XonoffShaking_Setup(state: BYTE);
PROCEDURE Set_routine;
PROCEDURE Unset_routine;
PROCEDURE Set_err_routine;
PROCEDURE Unset_err_routine;
PROCEDURE Verouille;
PROCEDURE Deverouille;
FUNCTION  GetDeviceName: BYTE;
FUNCTION  GetPortDevice: BYTE;
FUNCTION  ResetPortDevice: BYTE;
(* Fonctions accessibles via l'interruption n 21h (mode DEVICE DRIVER). *)
FUNCTION  Open_COMM: WORD;
FUNCTION  Close_COMM: INTEGER;
FUNCTION  IOStream_READ(VAR Voie_active: CHAR;VAR Format: WORD;
          VAR RTS_type, DTR_type, Xonoff_type: CHAR): BOOLEAN;
FUNCTION  IOStream_WRITE(VAR Voie_active: CHAR;VAR Format: WORD;
          VAR RTS_type, DTR_type, Xonoff_type: CHAR): BOOLEAN;
FUNCTION  CheckCOMMIn: BOOLEAN;
FUNCTION  CheckCOMMOut: BOOLEAN;
FUNCTION  ReadCOMM(VAR c: CHAR; nombre: WORD): INTEGER;
FUNCTION  WriteCOMM(VAR c: CHAR; nombre: WORD): INTEGER;
(* Fonction de recherche de STARCOMM.EXE en mmoire. *)
FUNCTION  Check_STARCOMM_Present: BYTE;



implementation

VAR
  reg88 : Registers ;


PROCEDURE Version(VAR NumVer: Chn4octets);
{ Retourne le numro de version (en ASCII) du pilote charg en RAM.           }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := 6;
      Intr($14,Dos.Registers(reg88));
      NumVer[1] := chr(al);
      NumVer[2] := '.';
      ax := di;
      NumVer[3] := chr(ah);
      NumVer[4] := chr(al)
    END;
    NumVer[0] := chr(4);
  END
  ELSE NumVer[0] := chr(0);
END;


FUNCTION Open_Port: BYTE;
{ Ouverture d'un port srie. Met  1 les signaux DTR et OUT2 et annule tous   }
{ les codes de comptabilisation d'erreurs en transmissions.                   }
{ Retourne un code 5,8 ou 9 si le port n'a put tre ouvert.                   }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $07;
      al := 0;
      dx := CommPort;
      Intr($14,Dos.Registers(reg88));
      Open_Port := ah
    END;
  END
END;


FUNCTION Close_Port: BYTE;
{ Fermeture d'un port srie. Met  0 les signaux de ctrl-modem. Retourne un   }
{ code 7 ou 10 si le port n'a put tre ferm (i.e. pilote non dsactiv!)     }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $07;
      al := 1;
      dx := CommPort;
      Intr($14,Dos.Registers(reg88));
      Close_Port := ah
    END;
  END
END;


FUNCTION Port_Opened: BOOLEAN;
{ Indique si un port srie est ouvert (TRUE) ou ferm.                        }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $07;
      al := 2;
      dx := CommPort;
      Intr($14,Dos.Registers(reg88));
      IF CommPort<4 THEN
      BEGIN
        IF ah=5 THEN ComExist[CommPort] := FALSE
          ELSE ComExist[CommPort] := TRUE
      END;
      IF al=1 THEN Port_Opened := TRUE
        ELSE Port_Opened := FALSE
    END;
  END
END;


FUNCTION Interdit_Port: BYTE;
{ Interdit l'accs au port COMi: point par "CommPort".                       }
{ Retourne le code d'erreur 10 si erreur de dsallocation des buffers lors de }
{ la fermeture du port. L'accs est bien interdit dans tous les cas (erreur   }
{ survenue ou non...).                                                        }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $0A;
      al := 0;
      dx := CommPort;
      Intr($14,Dos.Registers(reg88));
      Interdit_Port := ah
    END;
  END
END;


FUNCTION Autorise_Port: BYTE;
{ Autorise l'accs au port COMi: point par "CommPort" si possible.           }
{ Retourne le code d'erreur 5 si l'UART de ce port n'existe pas ! L'accs au  }
{ port reste alors interdit.                                                  }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $0A;
      al := 1;
      dx := CommPort;
      Intr($14,Dos.Registers(reg88));
      Autorise_Port := ah
    END;
  END
END;


FUNCTION SLOW_Ems: BYTE;
{ Initialise un port srie en mode d'mission lente sans modifier son tat    }
{ d'activit.                                                                 }
{ Retourne 5 si le port n'existe pas.                                         }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $07;
      al := 3;
      dx := CommPort;
      Intr($14,Dos.Registers(reg88));
      SLOW_Ems := ah
    END;
  END
END;


FUNCTION FAST_Ems: BYTE;
{ Initialise un port srie en mode d'mission rapide sans modifier son tat   }
{ d'activit.                                                                 }
{ Retourne 5 si le port n'existe pas.                                         }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $07;
      al := 4;
      dx := CommPort;
      Intr($14,Dos.Registers(reg88));
      FAST_Ems := ah
    END;
  END
END;


FUNCTION Send_SLOW: BOOLEAN;
{ Indique si un port srie est en mode d'mission lente (sous IT d'horloge).  }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $07;
      al := 5;
      dx := CommPort;
      Intr($14,Dos.Registers(reg88));
      IF al=1 THEN Send_SLOW := TRUE
        ELSE Send_SLOW := FALSE
    END;
  END
END;


PROCEDURE Get_Ports_Adresses;
{ Lit les adresses de base des 8250 dans la boite aux lettres du BIOS.        }
BEGIN
  BasePort1 := MEMW[$40:$00];
  BasePort2 := MEMW[$40:$02];
  BasePort3 := MEMW[$40:$04];
  BasePort4 := MEMW[$40:$06]
END;


FUNCTION Infos_Uart(VAR Uart_type: BYTE; VAR Uart_adresse: WORD;
              VAR Irq,FIFO_actif,Taille_FIFO: BYTE): BYTE;
{ Retour d'informations sur les UART utiliss.                                }
{ La fonction indique 0 si Ok; 5 si erreur (port non support).               }
BEGIN
  IF RS_accessible THEN
  BEGIN
    reg88.ah := $09;
    reg88.al := 0;
    reg88.dx := CommPort;
    Intr($14,Dos.Registers(reg88));
    Uart_type := reg88.al;
    Uart_adresse := reg88.bx;
    Irq := reg88.ch;
    IF reg88.cl=0 THEN
    BEGIN
      FIFO_actif := 0;
      Taille_FIFO := 1;
    END
    ELSE
    BEGIN
      FIFO_actif := 1;
      Taille_FIFO := reg88.cl
    END;
    Infos_Uart := reg88.ah;
  END
END;


FUNCTION Set_New_Uart(Uart_adresse: WORD;
              Irq,FIFO_actif,Taille_FIFO: BYTE): BYTE;
{ Dfinition de nouveaux paramtres physiques pour un port srie.             }
{ Retourne 0 si Ok,5 si port inexistant,11 si port ouvert,12 si adresse INOP. }
BEGIN
  IF RS_accessible THEN
  BEGIN
    reg88.ah := $09;
    reg88.al := 1;
    reg88.dx := CommPort;
    reg88.bx := Uart_adresse;
    reg88.ch := Irq;
    IF FIFO_actif=1 THEN reg88.cl := Taille_FIFO
      ELSE reg88.cl := 0;
    Intr($14,Dos.Registers(reg88));
    Set_New_Uart := reg88.ah;
  END
END;


PROCEDURE Infos_Buffs(VAR Nb_actifs, Nb_maxi: BYTE;
              VAR Taille_InBuff,Taille_OutBuff: WORD);
{ Retour d'informations sur les buffers utilisables par STARCOMM.             }
BEGIN
  IF RS_accessible THEN
  BEGIN
    reg88.ah := $0D;
    Intr($14,Dos.Registers(reg88));
    Taille_InBuff := reg88.bx;
    Taille_OutBuff := reg88.cx;
    Nb_actifs := reg88.dh;
    Nb_maxi := reg88.dl;
  END
END;


FUNCTION Init_Port(longueur, stop_bit, parity: CHAR; vitesse: LONGINT;
              VAR Taille_InBuff: WORD; VAR Taille_OutBuff: WORD): BYTE;
{ Fonction FACULTATIVE: 9600 Bds, no parity, 1 stop, 8 data-bit par dfaut.   }
{ La voie active est ncessairement celle gre par le pilote actif.          }
{ Paramtres:                                                                 }
{     longueur = '5', '6', '7', ou '8' bits,                                  }
{     stop_bit = '1' ou '2',                                                  }
{     parity   = <'P'|'p'>aire, <'I'|'i'>mpaire, <'N'|'n'>o parity,           }
{                <'T'|'t'>ravail, <'R'|'r'>epos                               }
{     vitesse  = (110,150,300,600,1200,2400,4800,9600,                        }
{                19200,28800,38400,57600,115200) bauds.                       }
{ Retourne 0 si OK, 1 si paramtres incorrectes, 2 si pilotes absents de RAM. }
VAR
  descripteur_format, vitess : BYTE ;
BEGIN
  Init_Port := 1;
  WITH reg88 DO
  BEGIN
    CASE longueur OF
      '5': descripteur_format := $00;
      '6': descripteur_format := $01;
      '7': descripteur_format := $02;
      '8': descripteur_format := $03;
      ELSE Exit
    END;
    CASE stop_bit OF
      '1': ;
      '2': descripteur_format := descripteur_format + $04;
      ELSE Exit
    END;
    CASE upcase(parity) OF
      'N': ;
      'I': descripteur_format := descripteur_format + 8;
      'P': descripteur_format := descripteur_format + 24;
      'T': descripteur_format := descripteur_format + 40;
      'R': descripteur_format := descripteur_format + 56;
      ELSE Exit
    END;
    IF vitesse=110 THEN vitess := 0
      ELSE IF vitesse=150 THEN vitess := 1
      ELSE IF vitesse=300 THEN vitess := 2
      ELSE IF vitesse=600 THEN vitess := 3
      ELSE IF vitesse=1200 THEN vitess := 4
      ELSE IF vitesse=2400 THEN vitess := 5
      ELSE IF vitesse=4800 THEN vitess := 6
      ELSE IF vitesse=9600 THEN vitess := 7
      ELSE IF vitesse=19200 THEN vitess := 8
      ELSE IF vitesse=28800 THEN vitess := 9
      ELSE IF vitesse=38400 THEN vitess := 10
      ELSE IF vitesse=57600 THEN vitess := 11
      ELSE IF vitesse=115200 THEN vitess := 12
      ELSE Exit;
    bl := descripteur_format;           (* Mise  jour init. du 8250.        *)
    bh := vitess;
    dx := CommPort;
    ah := $0B;
    IF RS_accessible THEN
    BEGIN                               (* Appel  notre pilote s'il existe  *)
      Intr($14,Dos.Registers(reg88));                             (* en RAM  *)
      Taille_InBuff := bx;
      Taille_OutBuff := cx;
      Init_Port := 0;
    END
    ELSE Init_Port := 2;
  END
END;


PROCEDURE Init_status(VAR Format: WORD);
{ Indique le format de comm. utilis par le port "CommPort".                  }
VAR
  Mem_Variable : ARRAY[1..3] OF BYTE        ;
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      es := Seg(Mem_Variable[1]);
      di := Ofs(Mem_Variable[1]);
      dx := CommPort;
      ah := $0C;
      Intr($14,Dos.Registers(reg88))
    END;
    Format := (Mem_Variable[2]*256) + Mem_Variable[3];
  END
END;


FUNCTION Reset_Init_status(Format: WORD): BYTE;
{ R-active le format indiqu par "Format" sur le port "CommPort".            }
{ Retourne 0 si OK, 1 si paramtre incorrecte, 2 si pilote absent de la RAM.  }
BEGIN
  WITH reg88 DO
  BEGIN
    bx := Format;                       (* Mise  jour init. du 8250.        *)
    dx := CommPort;
    ah := $0B;
    IF RS_accessible THEN
    BEGIN
      Intr($14,Dos.Registers(reg88));   (* Appel  notre pilote s'il existe  *)
      IF ah=0 THEN Reset_Init_status := 0                       (* en RAM    *)
        ELSE Reset_Init_status := 1;
    END
    ELSE Reset_Init_status := 2;
  END
END;


PROCEDURE Flush_buffers;
{ Vide totalement le buffer d'mission ET le buffer de rception.             }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      dx := CommPort;
      ah := $0E;
      Intr($14,Dos.Registers(reg88));
    END;
  END
END;


PROCEDURE Flush_InBuff;
{ Rinitialise les rceptions et vide totalement le buffer de rception.      }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      dx := CommPort;
      ah := $0F;
      Intr($14,Dos.Registers(reg88));
    END;
  END
END;


PROCEDURE Flush_OutBuff;
{ Rinitialise les missions et vide totalement le buffer d'mission.         }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      dx := CommPort;
      ah := $10;
      Intr($14,Dos.Registers(reg88));
    END;
  END
END;


PROCEDURE ResetPort_and_TimMAX(RdTim_MAX: BYTE; VAR Old_RdTim_MAX: BYTE;
          WrTim_MAX: BYTE; VAR Old_WrTim_MAX: BYTE);
{ R-initialise la chaine de comm. complte et redfini les valeurs des dlais}
{ autoriss avant d'obtenir des erreurs de time-out en lecture et en criture.}
{ Les anciennes valeurs sont rendues dans "Old_RdTim_MAX" et "Old_WrTim_MAX". }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $11;
      bh := RdTim_MAX;
      bl := WrTim_MAX;
      dx := CommPort;
      Intr($14,Dos.Registers(reg88));
      Old_RdTim_MAX := bh;
      Old_WrTim_MAX := bl
    END;
  END
END;


PROCEDURE Status_Trait_Erreurs(VAR mode: BYTE; VAR code: CHAR);
{ Indique l'tat de fonctionnement du processus de substitution des octets    }
{ errons en rception.                                                       }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $12;
      dx := CommPort;
      Intr($14,Dos.Registers(reg88));
      mode := al;
      code := Chr(bl);
    END;
  END
END;


FUNCTION Def_Trait_Erreurs(mode: BYTE; code: CHAR): BYTE;
{ Contrle du processus de substitution des octets errons en rception.      }
{ Retourne 1 (TRUE) si "mode" non valide; 0 (FALSE) sinon.                    }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      al := mode;
      bl := Ord(code);
      dx := CommPort;
      ah := $13;
      Intr($14,Dos.Registers(reg88));
      Def_Trait_Erreurs := ah
    END;
  END
END;


FUNCTION Change_com_port(Num_port: BYTE): BYTE;
{ Ferme tous les ports sauf celui spcifi. Retourne 9 si le manque de buffers}
{ interdit l'ouverture du port (sauf erreur interne, ce cas d'erreur est      }
{ normalement impossible !).                                                  }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      CommPort := Num_port;
      dx := CommPort;
      ah := $08;
      Intr($14,Dos.Registers(reg88));
      Change_com_port := ah
    END;
  END
END;


FUNCTION Attend_Buff_ems_vide(Temps_maxi: BYTE): BOOLEAN;
{ Cette fonction permet d'attendre que le buffer d'mission du port spcifi  }
{ soit compltement vide. (Dure d'attente maxi.  spcifier  l'appel !).    }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $1B;                        (* Code de la fonction.              *)
      al := Temps_maxi;
      dx := CommPort;
      Intr($14,Dos.Registers(reg88));   (* Appel  notre pilote.             *)
      IF ah=4 THEN Attend_Buff_ems_vide := FALSE
        ELSE Attend_Buff_ems_vide := TRUE;
    END;
  END
END;


FUNCTION CheckBufferIn(VAR nb_a_lire: WORD): BOOLEAN;
{ Demande l'tat du buffer de rception des donnes, sans supprimer d'octets. }
{ TRUE = des octets sont disponibles. FALSE = Aucun octet n'est disponible.   }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $1C;
      dx := CommPort;
      Intr($14,Dos.Registers(reg88));
      nb_a_lire := cx;
      IF (ah=0) AND (al=0) THEN CheckBufferIn := TRUE
        ELSE CheckBufferIn := FALSE;
    END;
  END
  ELSE CheckBufferIn := FALSE;
END;


FUNCTION CheckBufferOut(VAR place_libre: WORD): BOOLEAN;
{ Indique si le buffer de sortie srie peut encore recevoir des octets (TRUE).}
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $1D;
      dx := CommPort;
      Intr($14,Dos.Registers(reg88));
      place_libre := cx;
      IF (ah=0) AND (al=0) THEN CheckBufferOut := TRUE
        ELSE CheckBufferOut := FALSE;
    END;
  END
  ELSE CheckBufferOut := FALSE;
END;


FUNCTION ReadSerie(VAR c: CHAR; nombre: WORD; VAR Nb_received: WORD): BYTE;
{ Cette fonction permet la lecture de "nombre" octets depuis le port srie.   }
{ Code rendu: 0=bonne lecture, 2=Erreur en lecture (Nb_received<nombre, ...). }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $14;                        (* Code fonction de lecture.         *)
      es := Seg(c);                     (* Adresse ou stocker les octets lus.*)
      di := Ofs(c);
      cx := nombre;                     (* Nombre d'octet(s)  lire.         *)
      dx := CommPort;
      Intr($14,Dos.Registers(reg88));   (* Appel  notre pilote.             *)
      Nb_received := cx;                (* Nombre d'octets reu.             *)
      ReadSerie := ah                   (* Retour du code d'erreur.          *)
    END;
  END
END;


FUNCTION WriteSerie(VAR c: CHAR; nombre: WORD; VAR Nb_written: WORD): BYTE;
{ Envoi d'une chaine de "nombre" octets vers le port srie dj ouvert.       }
{ c en constitue le premier octet.                                            }
{ Code rendu: 0=criture russie, 3=Aucun octet  envoyer !?, 4=time-out...   }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $15;                        (* Code fonction d'criture.         *)
      es := Seg(c);                     (*Adresse d'o prendre le(s) octet(s)*)
      di := Ofs(c);
      cx := nombre;                     (* Nombre d'octet(s)  envoyer.      *)
      dx := CommPort;
      Intr($14,Dos.Registers(reg88));   (* Appel  notre pilote.             *)
      Nb_written := cx;                 (* Nombre d'octet(s) envoys.        *)
      WriteSerie := ah                  (* Retour du code erreur.            *)
    END;
  END
END;


FUNCTION ReadCarSerie(VAR c: CHAR): BYTE;
{ Cette fonction permet la lecture sans attente d'un octet depuis le buffer de}
{ rception du port srie spcifi.                                           }
{ Code rendu: 0=bonne lecture, 3=Aucun octet disponible (ou port ferm !...), }
{ 5=le port n'existe pas.                                                     }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $16;                        (* Code fonction de lecture.         *)
      dx := CommPort;
      Intr($14,Dos.Registers(reg88));   (* Appel  notre pilote.             *)
      c := Chr(al);                     (* Caractre ventuellement lu.      *)
      ReadCarSerie := ah                (* Retour du code d'erreur.          *)
    END;
  END
END;


FUNCTION WriteCarSerie(c: CHAR): BYTE;
{ Cette fonction permet d'crire sans attente un octet dans le buff. d'ems.   }
{ Code rendu: 0=bonne criture,3=Octet non mis (plus de place ou port ferm!)}
{ 5=le port n'existe pas.                                                     }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $17;                        (* Code fonction d'criture.         *)
      al := Ord(c);
      dx := CommPort;
      Intr($14,Dos.Registers(reg88));   (* Appel  notre pilote.             *)
      WriteCarSerie := ah               (* Retour du code d'erreur.          *)
    END;
  END
END;


FUNCTION Peek_rcp(VAR c: CHAR): BYTE;
{ Cette fonction permet de lire le prochain octet disponible dans le buffer   }
{ de rception, sans le retirer de ce buffer.                                 }
{ Code rendu: 0=bonne lecture, 3=Octet non lu (aucun dispo. ou port ferm!...)}
{ 5=le port n'existe pas.                                                     }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $18;                        (* Code fonction de lecture.         *)
      dx := CommPort;
      Intr($14,Dos.Registers(reg88));   (* Appel  notre pilote.             *)
      c := Chr(al);
      Peek_rcp := ah                    (* Retour du code d'erreur.          *)
    END;
  END
END;


FUNCTION Poke_rcp(c: CHAR): BYTE;
{ Cette fonction permet d'crire (sans attente) un octet dans le buffer de    }
{ rception du port spcifi.                                                 }
{ Code rendu: 0=bonne criture,3=Octet non crit (buff. plein ou port ferm !)}
{ 5=le port n'existe pas.                                                     }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $19;                        (* Code fonction d'criture.         *)
      al := Ord(c);
      dx := CommPort;
      Intr($14,Dos.Registers(reg88));   (* Appel  notre pilote.             *)
      Poke_rcp := ah                    (* Retour du code d'erreur.          *)
    END;
  END
END;


FUNCTION WriteCmde(VAR Cmde: CHAR; nombre: BYTE; UseDTR: BOOLEAN): BYTE;
{ Envoi d'une commande de "nombre" octets vers le port srie dj ouvert.     }
{ L'mission de cette chaine n'est pas soumise au contrle de flux, et restera}
{ constitue d'un seul bloc (A utiliser pour commander un modem...).          }
{ 'Cmde' constitue le premier octet de cette chaine=commande.                 }
{ Code rendu: 0=criture russie, 3=Aucun octet  envoyer !?...               }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $1A;                        (* Code fonction d'criture de Cmde. *)
      es := Seg(Cmde);                  (*Adresse d'o prendre le(s) octet(s)*)
      di := Ofs(Cmde);
      al := nombre;                     (* Nombre d'octet(s)  envoyer.      *)
      IF UseDTR THEN bh := 1 ELSE bh := 0; (*Utilisation de DTR comme indic.?*)
      dx := CommPort;
      Intr($14,Dos.Registers(reg88));   (* Appel  notre pilote.    *)
      WriteCmde := ah                   (* Retour du code erreur.            *)
    END;
  END
END;


PROCEDURE Etat_du_Modem(VAR Voie_active: CHAR; VAR Pret, Clear_to_send,
          Sonnerie, Porteuse, Changements, deltaDSR, deltaCTS, deltaRI,
          deltaDCD: BOOLEAN);
{ Indique si le modem est prt, recoit une sonnerie, ou obtient une porteuse  }
VAR
  Mem_Variable : ARRAY[1..10] OF BYTE       ;
  voie_num     : CHAR absolute Mem_Variable ;  (* '1'/'4' pour COM1:  COM4: *)
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      es := Seg(Mem_Variable[1]);
      di := Ofs(Mem_Variable[1]);
      dx := CommPort;
      ah := $20;
      al := 0;
      Intr($14,Dos.Registers(reg88))
    END;
    Mem_Variable[1] := Mem_Variable[1] + $31; (* Transcodage ASCII *)
    Voie_active := voie_num;
    IF Mem_Variable[2]=1 THEN Pret := TRUE
      ELSE Pret := FALSE;
    IF Mem_Variable[3]=1 THEN Clear_to_send := TRUE
      ELSE Clear_to_send := FALSE;
    IF Mem_Variable[4]=1 THEN Sonnerie := TRUE
      ELSE Sonnerie := FALSE;
    IF Mem_Variable[5]=1 THEN Porteuse := TRUE
      ELSE Porteuse := FALSE;
    IF Mem_Variable[6]=1 THEN Changements := TRUE
      ELSE Changements := FALSE;
    IF Mem_Variable[7]=1 THEN deltaDSR := TRUE
      ELSE deltaDSR := FALSE;
    IF Mem_Variable[8]=1 THEN deltaCTS := TRUE
      ELSE deltaCTS := FALSE;
    IF Mem_Variable[9]=1 THEN deltaRI := TRUE
      ELSE deltaRI := FALSE;
    IF Mem_Variable[10]=1 THEN deltaDCD := TRUE
      ELSE deltaDCD := FALSE;
  END
END;


PROCEDURE Set_DTR;
{ Positionne le signal DTR  1.                                               }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      di := $01;
      dx := CommPort;
      ah := $20;
      al := 1;
      Intr($14,Dos.Registers(reg88))
    END;
  END
END;


PROCEDURE Clear_DTR;
{ Positionne le signal DTR  0.                                               }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      di := $FE;
      dx := CommPort;
      ah := $20;
      al := 2;
      Intr($14,Dos.Registers(reg88))
    END;
  END
END;


PROCEDURE Set_RTS;
{ Positionne le signal RTS  1.                                               }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      di := $02;
      dx := CommPort;
      ah := $20;
      al := 1;
      Intr($14,Dos.Registers(reg88))
    END;
  END
END;


PROCEDURE Clear_RTS;
{ Positionne le signal RTS  0.                                               }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      di := $FD;
      dx := CommPort;
      ah := $20;
      al := 2;
      Intr($14,Dos.Registers(reg88))
    END;
  END
END;


PROCEDURE Set_OUT1;
{ Positionne le signal OUT1  1.                                              }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      di := $04;
      dx := CommPort;
      ah := $20;
      al := 1;
      Intr($14,Dos.Registers(reg88))
    END;
  END
END;


PROCEDURE Clear_OUT1;
{ Positionne le signal OUT1  0.                                              }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      di := $FB;
      dx := CommPort;
      ah := $20;
      al := 2;
      Intr($14,Dos.Registers(reg88))
    END;
  END
END;


PROCEDURE Send_break(duree: BYTE);
{ Envoit un signal de break-interrupt via le port srie.                      }
BEGIN
  IF RS_accessible THEN
  BEGIN
    reg88.bl := duree;
    reg88.ah := $1E;
    reg88.dx := CommPort;
    Intr($14,Dos.Registers(reg88))
  END;
END;


FUNCTION Errors_Report(VAR Buff_overflow, Engorgement, Parite,
         Stop_bit, Break_it: BYTE): BOOLEAN;
{ Indique si une/des erreur(s) est/sont mmorise(s) (retourne TRUE/FALSE).   }
{ Indique leur type et leurs nombres le cas chant.                          }
VAR
  Mem_Variable : ARRAY[1..5] OF BYTE ;
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      es := Seg(Mem_Variable[1]);
      di := Ofs(Mem_Variable[1]);
      dx := CommPort;
      ah := $1F;
      Intr($14,Dos.Registers(reg88))
    END;
    Buff_overflow := Mem_Variable[1];
    Engorgement := Mem_Variable[2];
    Parite := Mem_Variable[3];
    Stop_bit := Mem_Variable[4];
    Break_it := Mem_Variable[5];
    IF (reg88.al=0) THEN Errors_Report := FALSE
      ELSE Errors_Report := TRUE;
  END
END;


FUNCTION Port_Free: BOOLEAN;
{ Indique si le port srie est accessible.                                    }
{ i.e. "Notre It. y accde-t'elle?". Si NON, COM_Free := TRUE...              }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $25;
      dx := CommPort;
      Intr($14,Dos.Registers(reg88))
    END;
    IF (reg88.al=0) THEN Port_Free := FALSE
      ELSE Port_Free := TRUE;
  END
END;


FUNCTION HandShake_Status(Proto_type: BYTE;VAR SendEnabled: BOOLEAN): BYTE;
{ Indique si le protocole matriel spcifi est gr, et donne son mode de    }
{ de fonctionnement. Prcise l'tat du processus d'mission: CTS ou DSR      }
{ TRUE ou  FALSE.                                                            }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $21;
      al := Proto_type;
      dx := CommPort;
      Intr($14,Dos.Registers(reg88))
    END;
    IF (reg88.di=0) THEN SendEnabled := FALSE
      ELSE SendEnabled := TRUE;
    HandShake_status := reg88.al;
  END
END;


PROCEDURE HandShake_Setup(Proto_type: BYTE; state: BYTE);
{ Indique au pilote si le protocole RTS/CTS ou DTR/DSR doit tre utilis,     }
{ et prcise dans quel mode.                                                  }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $22;
      al := Proto_type;
      state := state AND $DF;
      IF state IN [Inactif,Local,Eloigne,Bilateral] THEN
        bh := state
      ELSE bh := 0;
      dx := CommPort;
      Intr($14,Dos.Registers(reg88))
    END;
  END
END;


FUNCTION XonoffShaking_Status(VAR SendEnabled: BOOLEAN;
         VAR Nb_Xoff: BYTE): BYTE;
{ Indique si le protoc. Xon/Xoff est gr en prcisant son mode d'utilisation.}
{ Indique l'tat du drapeau de contrle qui autorise/interdit les missions.  }
{ Fournit un compte-rendu: Valeurs des codes Xon et Xoff + Nb. de Xoff non    }
{ acquits par des arrives de Xon...                                         }
VAR
  Mem_Variable : ARRAY[1..5] OF BYTE ;
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      es := Seg(Mem_Variable[1]);
      di := Ofs(Mem_Variable[1]);
      dx := CommPort;
      ah := $23;
      Intr($14,Dos.Registers(reg88))
    END;
    Xon := Mem_Variable[1];
    Xoff := Mem_Variable[2];
    Nb_Xoff := Mem_Variable[3];
    IF (Mem_Variable[4]=Xon) THEN SendEnabled := TRUE
      ELSE SendEnabled := FALSE;
    XonoffShaking_Status := Mem_Variable[5];
  END
END;


PROCEDURE XonoffShaking_Setup(state: BYTE);
{ Indique au pilote si le protocole Xon/Xoff doit tre utilis, et dfinit les}
{ codes  utiliser pour Xon et Xoff. Prcise le mode de fonctionnement utile. }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $24;
      state := state AND $DF;
      IF state IN [Inactif,Local,Eloigne,Bilateral] THEN
        al := state
      ELSE al := 0;
      bh := Xon;
      bl := Xoff;
      dx := CommPort;
      Intr($14,Dos.Registers(reg88))
    END;
  END
END;


(* Placez ici vos variables "locales" associes  votre routine 'user': *)
(* VAR <.....>                                                          *)
PROCEDURE Routine; INTERRUPT;
(* !! ATTENTION !!  NE PLACER AUCUNE VARIABLE EN CET ENDROIT *)
BEGIN
  (* Placer ici la routine  excuter sur ordre rgulier du pilote. *)
  (* ... *)
  (* Fait suite: Du code spcial  NE PAS MODIFIER... *)
  INLINE($89/$EC (* mov sp,bp *)
   /$5D          (* pop bp    *)
   /$07          (* pop es    *)
   /$1F          (* pop ds    *)
   /$5F          (* pop di    *)
   /$5E          (* pop si    *)
   /$5A          (* pop dx    *)
   /$59          (* pop cx    *)
   /$5B          (* pop bx    *)
   /$58          (* pop ax    *)
   /$CB)         (* retf      *)
END;
PROCEDURE Set_routine;
{ Indique au pilote d'appeler la routine indique  chaque it. gnre.       }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $26;
      es := Seg(Routine);
      di := Ofs(Routine);
      dx := CommPort;
      Intr($14,Dos.Registers(reg88))
    END;
  END
END;


PROCEDURE Unset_routine;
{ Indique au pilote de ne plus appeler la routine indique plus tt.          }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $27;
      dx := CommPort;
      Intr($14,Dos.Registers(reg88))
    END;
  END
END;


PROCEDURE Err_Routine; INTERRUPT;
(* !! ATTENTION !!  NE PAS UTILISER DE VARIABLES AFIN DE CREER UN ROUTINE *)
(* RE-ENTRANTE ...                                                        *)
BEGIN
  (* Placer ici le code de traitement des erreurs sous Int. 14h *)
  (* Ne pas appeler l'interruption 21h !...                     *)
  (* "reg88.dx" contient le n de port ventuellement dsign  *)
  (* l'appel de la fonction de l'IT 14h qui a aboutie  gnrer *)
  (* l'erreur  traiter...                                      *)
  (* ... *)
  (* Fait suite: Du code spcial  NE PAS MODIFIER... *)
  INLINE($89/$EC (* mov sp,bp *)
   /$5D          (* pop bp    *)
   /$07          (* pop es    *)
   /$1F          (* pop ds    *)
   /$5F          (* pop di    *)
   /$5E          (* pop si    *)
   /$5A          (* pop dx    *)
   /$59          (* pop cx    *)
   /$5B          (* pop bx    *)
   /$58          (* pop ax    *)
   /$CB)         (* retf      *)
END;
PROCEDURE Set_err_routine;
{ Indique au pilote d'appeler la routine indique  chaque erreur sous l'It 14}
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $28;
      es := Seg(Err_Routine);
      di := Ofs(Err_Routine);
      Intr($14,Dos.Registers(reg88))
    END;
  END
END;


PROCEDURE Unset_err_routine;
{ Indique au pilote de ne plus appeler la routine de gestion des erreurs It14h}
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $29;
      Intr($14,Dos.Registers(reg88))
    END;
  END
END;


PROCEDURE Verouille;
{ Interdit au pilote d'tre dsinstall depuis la ligne de commande du DOS.   }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $2A;
      al := 1;
      bl := 1;
      Intr($14,Dos.Registers(reg88))
    END;
  END
END;


PROCEDURE Deverouille;
{ Autorise au pilote d'tre dsinstall depuis la ligne de commande du DOS.   }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $2A;
      al := 1;
      bl := 0;
      Intr($14,Dos.Registers(reg88))
    END;
  END
END;


FUNCTION GetDeviceName: BYTE;
{ Retourne le nom de STARCOMM vu comme un DEVICE DRIVER.                      }
{ "NomDevice" est directement mis  jour, sauf erreur 13 !                    }
VAR
  Nom : STRING[8] ;
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $2B;
      es := Seg(Nom[1]);
      di := Ofs(Nom[1]);
      Intr($14,Dos.Registers(reg88));
      IF ah=0 THEN NomDevice := Nom;
      GetDeviceName := ah
    END;
  END
END;


FUNCTION GetPortDevice: BYTE;
{ Indique le port srie physique actuellement interfac par le DEVICE.        }
{ Retourne 13 si STARCOMM.EXE n'est pas disponible en mode DEVICE DRIVER.     }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      al := 0;
      ah := $2C;
      Intr($14,Dos.Registers(reg88));
      IF ah=0 THEN GetPortDevice := al
        ELSE GetPortDevice := ah
    END;
  END
END;


FUNCTION ResetPortDevice: BYTE;
{ Oriente COMM: (s'il a t install) sur le port srie "CommPort".           }
{ Retourne 0 si port accept; 5 sinon.                                        }
BEGIN
  IF RS_accessible THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      al := 1;
      ah := $2C;
      dx := CommPort;
      Intr($14,Dos.Registers(reg88));
      ResetPortDevice := ah
    END;
  END
END;


FUNCTION Open_COMM: WORD;
{ Cette fonction permet l'ouverture du fichier constituant le port srie.     }
BEGIN
  IF NOT COMM_ouvert THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $3D;                            (* Code d'ouverture du fichier   *)
      ds := Seg(NomDevice[1]);              (* Segment du nom de 'fichier'   *)
      dx := Ofs(NomDevice[1]);              (* Offset du nom de 'fichier'    *)
      al := 2;                              (* Ouverture lecture/criture    *)
      msdos(Dos.Registers(reg88));          (* Appel aux fonctions du DOS    *)
      IF (Flags AND 1)<>0 THEN              (* Si erreur,                    *)
        Open_COMM := ax                     (* renvoi du code erreur         *)
      ELSE                                  (* Si pas erreur,                *)
      BEGIN
        Open_COMM          := 0;            (* code pas d'erreur             *)
        handler_voie_serie := ax;           (* Mmorise le tmoin            *)
        COMM_ouvert        := TRUE          (* Ouverture faite               *)
      END;
    END
  END;
END;


FUNCTION Close_COMM: INTEGER;
{ Cette fonction permet la fermeture du fichier constituant le port srie.    }
BEGIN
  IF COMM_ouvert THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $3E;                          (* Code fonction fermeture       *)
      bx := handler_voie_serie;           (* Tmoin du fichier srie       *)
      msdos(Dos.Registers(reg88));        (* Appel au DOS                  *)
      IF (Flags AND 1)<>0 THEN            (* Gestion du code d'erreur      *)
        Close_COMM := ax
      ELSE
      BEGIN
        Close_COMM := 0;
        COMM_ouvert := FALSE
      END;
    END;
  END
  ELSE Close_COMM := -1
END;


FUNCTION IOStream_READ(VAR Voie_active: CHAR;VAR Format: WORD;
         VAR RTS_type, DTR_type, Xonoff_type: CHAR): BOOLEAN;
{ Met  jour les paramtres fournis en arguments si le port est ouvert, ainsi }
{ que les variables gnrales "Xon" et "Xoff". Utilise, pour raliser cette   }
{ fonction, la voie IOCTL des pilotes .SYS de SERIAL MANAGER v1.1 et plus...  }
{ Retourne FALSE si OK; Retourne TRUE (= "Il y a eu une erreur !") si le      }
{ retour de fonction du DOS  lieu sur un repport de Carry...                 }
VAR
  buff : ARRAY[1..9] OF BYTE ;
BEGIN
  IF COMM_ouvert THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $44;
      al := 2;
      cx := 8;
      ds := Seg(buff[1]);
      dx := Ofs(buff[1]);
      bx := handler_voie_serie;
      msdos(Dos.Registers(reg88));
      IF (Flags AND 1)=0 THEN
      BEGIN
        Voie_active := Chr(buff[1]+1);
        Format := (buff[1] * 256) + buff[2];
        RTS_type := Chr(buff[3]);
        DTR_type := Chr(buff[4]);
        Xonoff_type := Chr(buff[5]);
        Xon := buff[6];
        Xoff := buff[7];
        IOStream_READ := FALSE;
      END
      ELSE IOStream_READ := TRUE;
    END
  END;
END;


FUNCTION IOStream_WRITE(VAR Voie_active: CHAR;VAR Format: WORD;
         VAR RTS_type, DTR_type, Xonoff_type: CHAR): BOOLEAN;
{ Envoit une squence spcifique de rinitialisation du port  utiliser, avec }
{ indications sur l'utilisation voulue des contrles de flux au pilote .SYS.  }
{ Cette chaine de commande est btie en fonction des paramtres reus en      }
{ arguments. La communication de cette chaine au pilote  lieu via l'interface}
{ du DOS (IOCTL).                                                             }
{ Retourne FALSE si OK; Retourne TRUE (= "Il y a eu une erreur !") si le      }
{ retour de fonction du DOS  lieu sur un repport de Carry...                 }
VAR
  buff : ARRAY[1..9] OF BYTE ;
BEGIN
  IF COMM_ouvert THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      buff[1] := Ord(Voie_active)-$30-1;
      ax := Format;
      buff[1] := ah;
      buff[2] := al;
      buff[3] := Ord(RTS_type);
      buff[4] := Ord(DTR_type);
      buff[5] := Ord(Xonoff_type);
      buff[6] := Xon;
      buff[7] := Xoff;
      ah := $44;
      al := 3;
      cx := 8;
      ds := Seg(buff[1]);
      dx := Ofs(buff[1]);
      bx := handler_voie_serie;
      msdos(Dos.Registers(reg88));
      IF (Flags AND 1)=0 THEN IOStream_WRITE := FALSE
        ELSE IOStream_WRITE := TRUE;
    END;
  END
END;


FUNCTION CheckCOMMIn: BOOLEAN;
{ Indique si des octets sont prsents dans le buffer de rception.            }
BEGIN
  IF COMM_ouvert THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $44;
      al := 6;
      bx := handler_voie_serie;
      msdos(Dos.Registers(reg88));
      IF al=0 THEN CheckCOMMIn := TRUE
        ELSE CheckCOMMIn := FALSE;
    END;
  END
  ELSE CheckCOMMIn := FALSE;
END;


FUNCTION CheckCOMMOut: BOOLEAN;
{ Indique s'il est possible d'crire des octets dans le buffer d'mission.    }
BEGIN
  IF COMM_ouvert THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $44;
      al := 7;
      bx := handler_voie_serie;
      msdos(Dos.Registers(reg88));
      IF al=0 THEN CheckCOMMOut := TRUE
        ELSE CheckCOMMOut := FALSE;
    END;
  END
  ELSE CheckCOMMOut := FALSE;
END;


FUNCTION ReadCOMM(VAR c: CHAR; nombre: WORD): INTEGER;
{ Cette fonction permet la lecture de n octet(s) depuis le port srie ouvert. }
BEGIN
  IF COMM_ouvert THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $3F;                           (* Code lecture fichier           *)
      bx := handler_voie_serie;            (* Tmoin du fichier srie        *)
      cx := nombre;                        (* Nombre d'octet(s)  recevoir   *)
      ds := Seg(c);                        (* Pour stocker octet(s) lu(s)... *)
      dx := Ofs(c);
      msdos(Dos.Registers(reg88));         (* Appel au DOS                   *)
      IF (Flags AND 1)<>0 THEN             (* Gestion du code d'erreur       *)
        ReadCOMM := ax                     (* Code erreur                    *)
      ELSE
        IF ax<>0 THEN ReadCOMM := 0        (* Pas d'erreur                   *)
          ELSE ReadCOMM := -1;
    END;
  END
END;


FUNCTION WriteCOMM(VAR c: CHAR; nombre: WORD): INTEGER;
{ Envoi de n octet(s) vers le port srie dj ouvert.                         }
BEGIN
  IF COMM_ouvert THEN
  BEGIN
    WITH reg88 DO
    BEGIN
      ah := $40;                           (* Code criture fichier          *)
      bx := handler_voie_serie;            (* Tmoin du fichier-driver...    *)
      ds := Seg(c);                        (* Adrs. octet(s)  mettre       *)
      dx := Ofs(c);
      cx := nombre;                        (* Nombre d'octet(s)  envoyer    *)
      msdos(Dos.Registers(reg88));         (* Appel au DOS                   *)
      IF (Flags AND 1)<>0 THEN             (* Gestion du code erreur         *)
        WriteCOMM := ax
      ELSE
        IF ax<>0 THEN WriteCOMM := 0       (* Pas d'erreur                   *)
          ELSE WriteCOMM := -1;
    END;
  END
END;


FUNCTION Check_STARCOMM_Present: BYTE;
{ Cette fonction permet de savoir si le pilote est charg en mmoire RAM, et  }
{ de quelle faon il a t charg (en BIOS ou en DEVICE DRIVER...).           }
{ Retourne: RS_accessible=TRUE si le pilote est prsent, FALSE sinon.         }
{           0=pilote non trouv, 1=STARCOMM charg BIOS, 2=charg en DEVICE-D.}
VAR
  Check : BYTE ;
BEGIN
  (* Le pilote est-il install en RAM et accessible par l'Int 14h ? *)
  Check := 0;
  WITH reg88 DO
  BEGIN
    ah := 6;
    al := 0;
    Intr($14,Dos.Registers(reg88));
    IF al<>0 THEN
    BEGIN
      RS_accessible := TRUE;      (* Int 14h disponible. *)
      Check := 1;                 (* Pilote au moins charg en ".EXE" *)
    END
    ELSE RS_accessible := FALSE
  END;
  (* Trouve-t'on le priphrique en RAM si STARCOMM est disponible ? *)
  IF RS_accessible THEN
    IF GetDeviceName=0 THEN Check := 2;
  (* Fin de procdure. *)
  Check_STARCOMM_Present := Check
END;


BEGIN
  COMM_ouvert := FALSE;              (* Le port DEVICE n'est pas ouvert. *)
  type_driver := Check_STARCOMM_Present;
  IF type_driver<>0 THEN Get_Ports_Adresses
END.
