{
ͻ
 NOM       : TESTSTAR.PAS                                                    
 FONCTION  : Dmonstration de l'utilisation de STARCOMM.EXE.                 
 VERSION   : v2.0 (premire dition).                                        
 LANGAGE   : TURBO PASCAL v4.0 et suivants.                                  
 SYNTAXE   : (path)> <path_pgm>TESTSTAR                                      
 REMARQUES :  Lors de l'utilisation de toute fonction de SERIAL MANAGER qui 
           : retourne un "boolean", il est conseill de vrifier que le      
           : pilote est accessible.  Sinon, le code retourn tant sans      
           : vritable  signification, votre programme pourrait ragir       
           : de faon "bizarre".                                             
           : La mthode la plus simple consiste  vrifier une fois pour     
           : toutes qu'un pilote est prsent, lors de toute entre dans votre
           : application:     - par le "BEGIN" initial du programme,         
           :                  (test fait systmatiquement par COMINTERF.TPU) 
           :                  - par un retour DOS aprs "EXIT".              
           :                  (appeler "type_driver := Check_COMM_Present"). 
           : Ceci car c'est uniquement sous DOS que le pilote peut (normale- 
           : ment...) avoir t ventuellement dsinstall.                  
           :  L'intialisation des ports, l'tat des contrles de flux du    
           : pilote, et le mode de traitement des erreurs ne sont pas        
           : modifis par TESTSTAR.                                          
 COPYRIGHT : (C)HETRU Fabrice 1991-1994                                      
ͼ
}



                          PROGRAM TestStar;



{$S+}  (* Contrle de la pile.......................: OUI *)
{$R-}  (* Contrle des dbordements.................: NON *)
{$E-}  (* Calcul avec des termes rels..............: NON *)
{$B+}  (* Evaluation boolenne performante..........: OUI *)
{$D-}  (* Informations de dbogage..................: NON *)
{$L-}  (* Accs aux symboles locaux pour dbogage...: NON *)


USES
  Crt, Dos, StarIntf;


CONST
  { Coordonnes des fentres de rception et de celle d'mission. }
  x1_com1:BYTE=02;   y1_com1:BYTE=02;   x2_com1:BYTE=19;   y2_com1:BYTE=16;
  x1_com2:BYTE=22;   y1_com2:BYTE=02;   x2_com2:BYTE=39;   y2_com2:BYTE=16;
  x1_com3:BYTE=42;   y1_com3:BYTE=02;   x2_com3:BYTE=59;   y2_com3:BYTE=16;
  x1_com4:BYTE=62;   y1_com4:BYTE=02;   x2_com4:BYTE=79;   y2_com4:BYTE=16;
  x1_send:BYTE=02;   y1_send:BYTE=19;   x2_send:BYTE=79;   y2_send:BYTE=24;
  { Coordonnes des positions courantes d'criture dans les fentres. }
  XSend:BYTE = 1;    YSend:BYTE = 1;
  Xcom1:BYTE = 1;    Ycom1:BYTE = 1;
  Xcom2:BYTE = 1;    Ycom2:BYTE = 1;
  Xcom3:BYTE = 1;    Ycom3:BYTE = 1;
  Xcom4:BYTE = 1;    Ycom4:BYTE = 1;


VAR
  Type_Crt_Mode,
  SendPort,
  OldSPort,
  error,i       : BYTE                ;
  seg_ecran     : WORD                ;
  VerDrive      : Chn4octets          ;
  PortState     : ARRAY[0..3] OF BYTE ;
  initialise,
  NewEms,
  termine       : BOOLEAN             ;
  Phrase        : STRING[79]          ;
  Eng,Parit,
  StopBit,
  BreakInt      : ARRAY[0..3] OF WORD ;


PROCEDURE WriteCadre(x1,y1,x2,y2:BYTE;c1,c2,c3,c4,c5,c6:CHAR);
  VAR
    i : BYTE ;
  BEGIN
    Window(1,1,80,25);
    GotoXY(x1,y1); WRITE(c1);
    FOR i := 1 TO x2-x1-1 DO WRITE(c2);
    WRITE(c3);
    FOR i := y1+1 TO y2-1 DO
    BEGIN
      GotoXY(x2,i);
      WRITE(c4)
    END;
    GotoXY(x2,y2); WRITE(c5);
    FOR i := x2-1 DOWNTO x1+1 DO
    BEGIN
      GotoXY(i,y2);
      WRITE(c2)
    END;
    GotoXY(x1,y2); WRITE(c6);
    FOR i := y2-1 DOWNTO y1+1 DO
    BEGIN
      GotoXY(x1,i);
      WRITE(c4)
    END;
  END;


PROCEDURE Setup_Screen;
  BEGIN
    ClrScr;
    TextColor(Black); TextBackGround(White);
    GotoXY(1,1); ClrEol;
    GotoXY(18,1); WRITE('TESTSTAR v2.0 pour STARCOMM ver ',VerDrive);
    GotoXY(67,1); WRITE('(C)HETRU 1994');
    GotoXY(1,25); ClrEol;
    GotoXY(4,25);
    WRITE('Ctrl-Fi:Emission COMiF2 testEms->F9:lentes F10:rapides'+
          'HOME Vide buff.ESC');
    TextColor(LightGray); TextBackGround(Black);
    IF PortState[0] IN [0,8] THEN
    BEGIN
      WriteCadre(x1_com1,y1_com1,x2_com1,y2_com1,'','','','','','');
      HighVideo;
      GotoXY(x1_com1+2,y1_com1); WRITE('COM1:ems ');
      CommPort := 0;
      IF Send_SLOW THEN WRITE('lente') ELSE WRITE('rapide');
      LowVideo;
    END
    ELSE
    BEGIN
      IF PortState[0]=5 THEN
      BEGIN
        WriteCadre(x1_com1,y1_com1,x2_com1,y2_com1,'','','','','','');
        GotoXY(x1_com1+1,y2_com1+1); WRITE('PORT NON RECONNU');
      END
      ELSE
      BEGIN
        WriteCadre(x1_com1,y1_com1,x2_com1,y2_com1,'','-','','|','','');
        GotoXY(x1_com1+1,y2_com1+1); WRITE('Plus de buffers!')
      END;
      GotoXY(x1_com1+7,y1_com1); WRITE('COM1')
    END;
    IF PortState[1] IN [0,8] THEN
    BEGIN
      WriteCadre(x1_com2,y1_com2,x2_com2,y2_com2,'','','','','','');
      HighVideo;
      GotoXY(x1_com2+2,y1_com2); WRITE('COM2:ems ');
      CommPort := 1;
      IF Send_SLOW THEN WRITE('lente') ELSE WRITE('rapide');
      LowVideo;
    END
    ELSE
    BEGIN
      IF PortState[1]=5 THEN
      BEGIN
        WriteCadre(x1_com2,y1_com2,x2_com2,y2_com2,'','','','','','');
        GotoXY(x1_com2+1,y2_com2+1); WRITE('PORT NON RECONNU');
      END
      ELSE
      BEGIN
        WriteCadre(x1_com2,y1_com2,x2_com2,y2_com2,'','-','','|','','');
        GotoXY(x1_com2+1,y2_com2+1); WRITE('Plus de buffers!')
      END;
      GotoXY(x1_com2+7,y1_com2); WRITE('COM2')
    END;
    IF PortState[2] IN [0,8] THEN
    BEGIN
      WriteCadre(x1_com3,y1_com3,x2_com3,y2_com3,'','','','','','');
      HighVideo;
      GotoXY(x1_com3+2,y1_com3); WRITE('COM3:ems ');
      CommPort := 2;
      IF Send_SLOW THEN WRITE('lente') ELSE WRITE('rapide');
      LowVideo;
    END
    ELSE
    BEGIN
      IF PortState[2]=5 THEN
      BEGIN
        WriteCadre(x1_com3,y1_com3,x2_com3,y2_com3,'','','','','','');
        GotoXY(x1_com3+1,y2_com3+1); WRITE('PORT NON RECONNU');
      END
      ELSE
      BEGIN
        WriteCadre(x1_com3,y1_com3,x2_com3,y2_com3,'','-','','|','','');
        GotoXY(x1_com3+1,y2_com3+1); WRITE('Plus de buffers!')
      END;
      GotoXY(x1_com3+7,y1_com3); WRITE('COM3')
    END;
    IF PortState[3] IN [0,8] THEN
    BEGIN
      WriteCadre(x1_com4,y1_com4,x2_com4,y2_com4,'','','','','','');
      HighVideo;
      GotoXY(x1_com4+2,y1_com4); WRITE('COM4:ems ');
      CommPort := 3;
      IF Send_SLOW THEN WRITE('lente') ELSE WRITE('rapide');
      LowVideo;
    END
    ELSE
    BEGIN
      IF PortState[3]=5 THEN
      BEGIN
        WriteCadre(x1_com4,y1_com4,x2_com4,y2_com4,'','','','','','');
        GotoXY(x1_com4+1,y2_com4+1); WRITE('PORT NON RECONNU');
      END
      ELSE
      BEGIN
        WriteCadre(x1_com4,y1_com4,x2_com4,y2_com4,'','-','','|','','');
        GotoXY(x1_com4+1,y2_com4+1); WRITE('Plus de buffers!')
      END;
      GotoXY(x1_com4+7,y1_com4); WRITE('COM4')
    END;
    WriteCadre(x1_send,y1_send,x2_send,y2_send,'','','','','','');
    HighVideo;
    GotoXY(x1_send+26,y1_send); WRITE('Emission sur le port COM1:');
    CommPort := 0;
    LowVideo
  END;


PROCEDURE Status_Port;
VAR
  x_com,y_com : BYTE    ;
  Err_sous_it : BOOLEAN ;
  Buff_ovrfl,
  Engorg,
  Parite_chk,
  SBit,BrkIt  : BYTE    ;
  changements,
  Pret,
  Clear_to_send,
  Sonnerie,
  Porteuse,
  dDSR, dCTS,
  dRI, dDCD   : BOOLEAN ;
  Num_Voie    : CHAR    ;
  SendOK      : BOOLEAN ;
  NbXoff      : BYTE    ;
BEGIN
  CASE CommPort OF
    0: BEGIN x_com:=x1_com1; y_com:=y2_com1; END;
    1: BEGIN x_com:=x1_com2; y_com:=y2_com2; END;
    2: BEGIN x_com:=x1_com3; y_com:=y2_com3; END;
    3: BEGIN x_com:=x1_com4; y_com:=y2_com4; END
  END;
  (* Bilan des erreurs raporte(s) par la liaison bas niveau. *)
  Err_sous_it := Errors_Report(Buff_ovrfl,Engorg,Parite_chk,SBit,BrkIt);
  IF Err_sous_it THEN
  BEGIN
    Window(1,1,80,25);
    IF Engorg>0 THEN
    BEGIN
      GotoXY(x_com+3,y_com+2);
      WRITE('Engorgements');
      Delay(100);
      GotoXY(x_com+3,y_com+2);
      WRITE('            ');
    END;
    IF Parite_chk>0 THEN
    BEGIN
      GotoXY(x_com+6,y_com+2);
      WRITE('Parit');
      Delay(100);
      GotoXY(x_com+6,y_com+2);
      WRITE('      ');
    END;
    IF SBit>0 THEN
    BEGIN
      GotoXY(x_com+3,y_com+2);
      WRITE('Bit d''arrt');
      Delay(100);
      GotoXY(x_com+3,y_com+2);
      WRITE('            ');
    END;
    IF BrkIt>0 THEN
    BEGIN
      GotoXY(x_com+7,y_com+2);
      WRITE('BREAK');
      Delay(100);
      GotoXY(x_com+7,y_com+2);
      WRITE('     ');
    END
  END;
  (* Mise  jour des indicateurs d'tat du modem. *)
  Num_Voie := Chr(CommPort+$31);
  Etat_du_Modem(Num_Voie, Pret, Clear_to_send, Sonnerie,
                Porteuse, changements, dDSR, dCTS, dRI, dDCD);
  IF changements OR initialise THEN
  BEGIN
    Window(1,1,80,25);
    GotoXY(x_com+2,y_com+1);
    IF Pret THEN WRITE('DSR')
      ELSE
      BEGIN
        IF dDSR THEN
          BEGIN WRITE('DSR'); GotoXY(x_com+2,y_com+1); Delay(10); END;
        WRITE('dsr')
      END;
    GotoXY(x_com+6,y_com+1);
    IF Clear_to_send THEN WRITE('CTS')
      ELSE
      BEGIN
        IF dCTS THEN
          BEGIN WRITE('CTS'); GotoXY(x_com+6,y_com+1); Delay(10); END;
        WRITE('cts')
      END;
    GotoXY(x_com+10,y_com+1);
    IF Sonnerie THEN WRITE('RI')
      ELSE
      BEGIN
        IF dRI THEN
          BEGIN WRITE('RI'); GotoXY(x_com+10,y_com+1); Delay(10); END;
        WRITE('ri')
      END;
    GotoXY(x_com+13,y_com+1);
    IF Porteuse THEN WRITE('DCD')
      ELSE
      BEGIN
        IF dDCD THEN
          BEGIN WRITE('DCD'); GotoXY(x_com+13,y_com+1); Delay(10); END;
        WRITE('dcd')
      END;
  END;
  (* Indication du status du protocole Xon/Xoff s'il est utilis en *)
  (* mode local ou en mode bilatral.                               *)
  IF XonoffShaking_Status(SendOK,NbXoff) IN [Ord('L'),Ord('B')] THEN
  BEGIN
    Dec(x_com); Dec(y_com);
    IF SendOK THEN
    BEGIN
      MEM[seg_ecran:2*((80*y_com)+x_com+5)] := Ord('X');
      MEM[seg_ecran:2*((80*y_com)+x_com+6)] := Ord('O');
      MEM[seg_ecran:2*((80*y_com)+x_com+7)] := Ord('N');
      MEM[seg_ecran:2*((80*y_com)+x_com+8)] := Ord('/');
      MEM[seg_ecran:2*((80*y_com)+x_com+9)] := Ord('X');
      MEM[seg_ecran:2*((80*y_com)+x_com+10)] := Ord('o');
      MEM[seg_ecran:2*((80*y_com)+x_com+11)] := Ord('f');
      MEM[seg_ecran:2*((80*y_com)+x_com+12)] := Ord('f');
    END
    ELSE
    BEGIN
      MEM[seg_ecran:2*((80*y_com)+x_com+5)] := Ord('X');
      MEM[seg_ecran:2*((80*y_com)+x_com+6)] := Ord('o');
      MEM[seg_ecran:2*((80*y_com)+x_com+7)] := Ord('n');
      MEM[seg_ecran:2*((80*y_com)+x_com+8)] := Ord('/');
      MEM[seg_ecran:2*((80*y_com)+x_com+9)] := Ord('X');
      MEM[seg_ecran:2*((80*y_com)+x_com+10)] := Ord('O');
      MEM[seg_ecran:2*((80*y_com)+x_com+11)] := Ord('F');
      MEM[seg_ecran:2*((80*y_com)+x_com+12)] := Ord('F')
    END;
  END
END;


PROCEDURE Input_Port;
VAR
  caract     : CHAR ;
  Nb_a_lire,
  Received   : WORD ;
BEGIN
  IF CheckBufferIn(Nb_a_lire) THEN
  BEGIN
    CASE CommPort OF
      0: BEGIN
           Window(x1_com1+1,y1_com1+1,x2_com1-1,y2_com1-1);
           GotoXY(Xcom1,Ycom1)
         END;
      1: BEGIN
           Window(x1_com2+1,y1_com2+1,x2_com2-1,y2_com2-1);
           GotoXY(Xcom2,Ycom2)
         END;
      2: BEGIN
           Window(x1_com3+1,y1_com3+1,x2_com3-1,y2_com3-1);
           GotoXY(Xcom3,Ycom3)
         END;
      3: BEGIN
           Window(x1_com4+1,y1_com4+1,x2_com4-1,y2_com4-1);
           GotoXY(Xcom4,Ycom4)
         END;
    END;
    REPEAT
      error := ReadSerie(caract,1,Received);
      Dec(Nb_a_lire);
      WRITE(caract);
    UNTIL (Nb_a_lire=0) OR (error<>0);
    CASE CommPort OF
      0: BEGIN Xcom1 := WhereX; Ycom1 := WhereY END;
      1: BEGIN Xcom2 := WhereX; Ycom2 := WhereY END;
      2: BEGIN Xcom3 := WhereX; Ycom3 := WhereY END;
      3: BEGIN Xcom4 := WhereX; Ycom4 := WhereY END;
    END;
  END
END;


PROCEDURE Output_Port;
VAR
  caract : CHAR ;
  Nb_wr  : WORD ;
  (* Procdure d'indication d'une erreur. *)
PROCEDURE Message(message: STRING);
  BEGIN
    Window(1,1,80,25);
    GotoXY(78-Length(message),y2_send);
    WRITE(message); Delay(300);
    GotoXY(78-Length(message),y2_send);
    FOR i:=1 TO Length(message) DO WRITE('')
  END;
  (* Fin proc. msg d'erreur. *)
BEGIN
  Window(x1_send+1,y1_send+1,x2_send-1,y2_send-1);
  GotoXY(XSend,YSend);
  IF KeyPressed THEN
  BEGIN
    CommPort := SendPort;
    caract := ReadKey;
    CASE caract OF
      #27: termine := TRUE;
      #0: BEGIN
        IF KeyPressed THEN
        BEGIN
          caract := ReadKey;
          CASE caract OF
            #94: BEGIN SendPort := 0; ClrScr END;
            #95: BEGIN SendPort := 1; ClrScr END;
            #96: BEGIN SendPort := 2; ClrScr END;
            #97: BEGIN SendPort := 3; ClrScr END;
            #60: BEGIN  (* Touche F2: Emission de la phrase de test...   *)
                   error := WriteSerie(Phrase[1],Length(Phrase),Nb_wr);
                   IF error=0 THEN WRITE(Phrase)
                     ELSE
                     BEGIN
                       FOR i := 1 TO Nb_wr DO WRITE(Phrase[i]);
                       CASE error OF
                         4: Message('TIME-OUT mission');
                         5: Message('Port srie NON reconnu')
                       END;
                     END
                 END;
            #67: IF SLOW_Ems=0 THEN
                 BEGIN
                   Message('Ems LENTES');
                   NewEMS := TRUE
                 END;
            #68: IF FAST_Ems=0 THEN
                 BEGIN
                   Message('Ems RAPIDES');
                   NewEMS := TRUE
                 END;
            #71: BEGIN  (* Touche HOME: Effacement cont. fentre+buffers *)
                   Flush_buffers;
                   CASE CommPort OF
                     0: BEGIN
                          Window(x1_com1+1,y1_com1+1,x2_com1-1,y2_com1-1);
                          Xcom1 := 1; Ycom1 := 1
                        END;
                     1: BEGIN
                          Window(x1_com2+1,y1_com2+1,x2_com2-1,y2_com2-1);
                          Xcom2 := 1; Ycom2 := 1
                        END;
                     2: BEGIN
                          Window(x1_com3+1,y1_com3+1,x2_com3-1,y2_com3-1);
                          Xcom3 := 1; Ycom3 := 1
                        END;
                     3: BEGIN
                          Window(x1_com4+1,y1_com4+1,x2_com4-1,y2_com4-1);
                          Xcom4 := 1; Ycom4 := 1
                        END;
                   END;
                   ClrScr;
                   Window(x1_send+1,y1_send+1,x2_send-1,y2_send-1); ClrScr
                 END;
            END
          END;
        END;
      ELSE
      BEGIN
        IF caract=#03 THEN error := 0
          ELSE error := WriteSerie(caract,1,Nb_wr);
        CASE error OF
          4: Message('TIME-OUT mission');
          5: Message('Port srie NON reconnu');
          ELSE
          BEGIN
            CASE caract OF
              #10: GotoXY(1,WhereY);
              #13: WRITELN;
              #08: WRITE(caract+' '+caract);
              #09: WRITE('       ');
              ELSE WRITE(caract)
            END;
          END
        END;
      END
    END;
    XSend := WhereX; YSend := WhereY;
  END
END;


BEGIN
  CheckBreak := FALSE; (* Pas de Ctrl-Break systme autoris  l'oprateur. *)
  termine := FALSE;
  initialise := TRUE;
  Phrase := #10+#13+'Le rapide renard marron a saut 0123456789 fois'+
            + ' par dessus le dos de LASSIE';
  Type_Crt_Mode := MEM[$40:$49];
  IF NOT (Type_Crt_Mode IN [2,3,7]) THEN TextMode(C80);
  IF MEM[$40:$49]=7 THEN seg_ecran := $B000
    ELSE seg_ecran := $B800;
  SendPort := 0;
  IF type_driver<>0 THEN
  BEGIN
    Version(VerDrive);
    FOR CommPort := 0 TO 3 DO PortState[CommPort] := Open_Port;
    Setup_Screen;
    REPEAT
      FOR CommPort := 0 TO 3 DO
      BEGIN
        IF PortState[CommPort] IN [0,8] THEN
        BEGIN
          (* Bilan sur les erreurs en rceptions, les signaux d'tat de *)
          (* modem, ET les modes de contrles de flux actifs.           *)
          Status_Port;
          (* Saisies des rceptions sur les ports sries et info. sur les *)
          (* erreurs ventuellement dclenches en rception...           *)
          Input_Port
        END;
        IF CommPort=3 THEN initialise := FALSE
      END;
      (* Traitement du clavier pour grer les missions. *)
      OldSPort := SendPort;
      NewEms := FALSE;
      Output_Port;
      IF SendPort<>OldSPort THEN
      BEGIN
        Window(1,1,80,25);
        HighVideo;
        GotoXY(x1_send+50,y1_send);
        WRITE(Chr(SendPort+$31));
        LowVideo
      END;
      IF NewEms THEN
      BEGIN
        Window(1,1,80,25);
        HighVideo;
        CASE CommPort OF
          0: GotoXY(x1_com1+11,y1_com1);
          1: GotoXY(x1_com2+11,y1_com2);
          2: GotoXY(x1_com3+11,y1_com3);
          3: GotoXY(x1_com4+11,y1_com4)
        END;
        IF Send_SLOW THEN WRITE('lente') ELSE WRITE('rapide');
        LowVideo;
        IF Send_SLOW THEN WRITE('')
      END;
    UNTIL termine;
    Window(1,1,80,25);
    ClrScr;
    GotoXY(1,2);
    WRITELN('TESTSTAR: Communication simultanne sur les 4 ports srie.');
    IF type_driver IN [1,2] THEN
      WRITELN('STARCOMM vs ',VerDrive,' gre les voies asynchrones.');
    FOR CommPort := 0 TO 3 DO
      IF Close_Port=7 THEN
        WRITELN('Port COM',chr(CommPort+$31),' impossible  fermer !');
  END
  ELSE
  BEGIN
    WRITELN('TESTSTAR: Communication simultanne sur les 4 ports srie.');
    WRITELN('Erreur: STARCOMM.EXE n''est pas install en mmoire !')
  END;
END.
